<databaseChangeLog xmlns="http://www.liquibase.org/xml/ns/dbchangelog" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.2.xsd">
    <changeSet  author="SYSTEM" id="DUKH-17-updatebalances.xml" runOnChange="true" runInTransaction="true">
        <createProcedure dbms="h2,!oracle, postgresql" encoding="UTF-8" >
            <![CDATA[CREATE OR REPLACE FUNCTION updatebalances(accountid bigint, amount numeric, OUT vrowscount integer, OUT vbalancebefore numeric, OUT vbalanceafter numeric)
            RETURNS record
            LANGUAGE plpgsql
            AS $$
            DECLARE
            VTYPE  int8;
            UPD_ROW_COUNT int;
            BEGIN
            SELECT BalanceTypeID, Balance
            INTO STRICT VTYPE,VBALANCEBEFORE
            FROM MPAY_ACCOUNTS
            WHERE ID = ACCOUNTID for update;
            VBALANCEAFTER := VBALANCEBEFORE + AMOUNT;
            IF VTYPE = 1 THEN
            UPDATE MPAY_ACCOUNTS SET balance = VBALANCEAFTER
            WHERE id = ACCOUNTID AND VBALANCEAFTER >= 0;
            GET DIAGNOSTICS UPD_ROW_COUNT = ROW_COUNT;
            VROWSCOUNT := UPD_ROW_COUNT;
            ELSE
            IF VTYPE = 2 THEN
            UPDATE MPAY_ACCOUNTS SET balance = VBALANCEAFTER
            WHERE id = ACCOUNTID AND VBALANCEAFTER <= 0;
            GET DIAGNOSTICS UPD_ROW_COUNT = ROW_COUNT;
            VROWSCOUNT := UPD_ROW_COUNT;
            ELSE
            UPDATE MPAY_ACCOUNTS SET balance = VBALANCEAFTER
            WHERE id = ACCOUNTID;
            GET DIAGNOSTICS UPD_ROW_COUNT = ROW_COUNT;
            VROWSCOUNT := UPD_ROW_COUNT;
            END IF;
            END IF;
            RETURN;
            END; $$
            ;]]>
        </createProcedure>
    </changeSet>
</databaseChangeLog>
